#include "stdafx.h"
#include "GameTool.h"

CGameTool::CGameTool(void)
{
	toolEnable = FALSE;
	gameHwnd = NULL;
	hDc = NULL;
	pix_data = NULL;
}

CGameTool::~CGameTool(void)
{
	if (gameHwnd!=NULL)
		::ReleaseDC(gameHwnd,hDc);
	if(pix_data != NULL)
		delete[] pix_data;
}

void CGameTool::startWork()
{
	toolEnable = TRUE;
}

void CGameTool::stopWork()
{
	toolEnable = FALSE;
}

BOOL CGameTool::isWorking()
{
	return toolEnable;
}

void CGameTool::sleep(int mSecond)
{
	if(toolEnable)
	{
		DWORD d_begin = GetTickCount()+mSecond;
		DWORD d_end = GetTickCount();
		while(toolEnable&&TRUE)
		{
			if(d_end>=d_begin)
				break;
			else
				d_end = GetTickCount();
			Sleep(10);
		}
	}
}

CString  CGameTool::getTimeFileName()
{
	CString str;
	CTime time;
	time = CTime::GetCurrentTime();
	str = time.Format("%Y%m%d%H%M%S");
	return str;
}

CString CGameTool::getFomatTime()
{
	CString str;
	CTime time;
	time = CTime::GetCurrentTime();
	str = time.Format("%Y-%m-%d %H:%M:%S");
	return str;
}

HDC CGameTool::getGameHdc()
{
	return this->hDc;
}

BOOL CGameTool::setGameHwnd(HWND hwnd)
{
	if(hwnd==NULL)
	{
		AfxMessageBox("ҾΪ");
		return FALSE;
	}
	//else
	//{
	//	TCHAR className[255]={0};
	//	::GetClassName(hwnd,className,255);
	//	if (_tcscmp("MacromediaFlashPlayerActiveX",className)!=0)
	//	{
	//		AfxMessageBox("Ϸûҵ");
	//		return FALSE;
	//	}
	//}
	this->gameHwnd = hwnd;
	this->hDc = ::GetDC(this->gameHwnd);
	CRect gRect;
	::GetClientRect(hwnd,&gRect);
	pix_width = gRect.Width();
	pix_height = gRect.Height();
	return TRUE;
}

HWND CGameTool::getGameHwnd()
{
	return this->gameHwnd;
}

void CGameTool::releaseHwnd()
{
	this->gameHwnd = NULL;
}

HWND CGameTool::findFlashHwnd(HWND ParentWnd)
{
	CString wName = "MacromediaFlashPlayerActiveX";
	HWND hWndNext = ::GetWindow(ParentWnd, GW_CHILD); 
	TCHAR ClassName[128];
	while (hWndNext != NULL)
	{
		::GetClassName(hWndNext,ClassName,sizeof(ClassName)/sizeof(TCHAR));
		if (_tcscmp(ClassName,wName)==0)
			return hWndNext;
		HWND findWnd = findWithClassName(hWndNext,wName);//ҵӾٴӾݹ
		if (findWnd)
			return findWnd;
		hWndNext = ::GetWindow(hWndNext, GW_HWNDNEXT);
	}
	return NULL;
}


HWND CGameTool::findWithClassName(HWND ParentWnd,CString wName)
{
	//FLASH:"MacromediaFlashPlayerActiveX"
	HWND hWndNext = ::GetWindow(ParentWnd, GW_CHILD); 
	TCHAR ClassName[128];
	while (hWndNext != NULL)
	{
		::GetClassName(hWndNext,ClassName,sizeof(ClassName)/sizeof(TCHAR));
		if (_tcscmp(ClassName,wName)==0)
			return hWndNext;
		HWND findWnd = findWithClassName(hWndNext,wName);//ҵӾٴӾݹ
		if (findWnd)
			return findWnd;
		hWndNext = ::GetWindow(hWndNext, GW_HWNDNEXT);
	}
	return NULL;
}

void CGameTool::updatePixel()
{
	try
	{
		////////´Ӿȡλͼ///////
		// 
		HDC hdcScreen = GetDC(gameHwnd);
		HDC hdc = CreateCompatibleDC(hdcScreen);
		HBITMAP hbmp = CreateCompatibleBitmap(hdcScreen, pix_width, pix_height);
		HBITMAP hOldbmp = (HBITMAP)SelectObject(hdc, hbmp);
		//
		if (hDc != NULL)
			::BitBlt(hdc,0,0,pix_width,pix_height,hDc,0,0,SRCCOPY);
		//ͷ
		DeleteDC(hdc);
		DeleteObject(hOldbmp);
		ReleaseDC(NULL, hdcScreen);
		////////´λͼȡ///////
		CBitmap bitmap;
		bitmap.Attach(hbmp);
		BITMAP bm;
		bitmap.GetBitmap(&bm);
		if(this->pix_data == NULL)
		{
			this->nbyte = bm.bmBitsPixel/8;//һռ4ֽR G B NULL
			//bmWidthBytesһе bmWidthBytes=bmWidth*nbyte
			this->bmWidthBytes = bm.bmWidthBytes;
			this->bitmapSize = this->bmWidthBytes*bm.bmHeight;
			this->pix_data = new BYTE[bitmapSize];
		}
		::ZeroMemory(this->pix_data,bitmapSize);//֮ǰ
		bitmap.GetBitmapBits(bitmapSize, this->pix_data);
		bitmap.Detach();
		DeleteObject(hbmp);
	}
	catch (CMemoryException* e)
	{
		char info[512] = {0};
		e->GetErrorMessage(info,512);
		println("%s",info);
	}
	catch (CFileException* e)
	{
		char info[512] = {0};
		e->GetErrorMessage(info,512);
		println("%s",info);
	}
	catch (CException* e)
	{
		char info[512] = {0};
		e->GetErrorMessage(info,512);
		println("%s",info);
	}
}

void CGameTool::captureData()
{
	CBitmap bitmap;
	//nbyte*8 R,G,B,NULL 32λ
	bitmap.CreateBitmap(pix_width,pix_height,1,32,pix_data);
	OpenClipboard(NULL);
	EmptyClipboard();
	SetClipboardData(CF_BITMAP, bitmap.GetSafeHandle());
	CloseClipboard();
}

void CGameTool::captureScreen()
{
	CRect rc;
	::GetClientRect(gameHwnd, &rc);
	// 
	HDC hdcScreen = ::GetDC(gameHwnd);
	HDC hdc = CreateCompatibleDC(hdcScreen);
	HBITMAP hbmp = CreateCompatibleBitmap(hdcScreen, rc.Width(), rc.Height());
	HBITMAP hOldbmp = (HBITMAP)SelectObject(hdc, hbmp);
	//Ƶճ 
	if (hDc != NULL)
		::BitBlt(hdc,0,0,pix_width,pix_height,hDc,0,0,SRCCOPY);
	OpenClipboard(NULL);
	EmptyClipboard();
	SetClipboardData(CF_BITMAP, hbmp);
	CloseClipboard();

	//ͷ
	DeleteDC(hdc);
	DeleteObject(hbmp);
	DeleteObject(hOldbmp);
	::ReleaseDC(NULL, hdcScreen);
}

int CGameTool::ident(CString trait,CString libTrait[]) 
{
	int tempPos[NUMBER_LENGTH];
	int tempValue[NUMBER_LENGTH];
	memset(tempPos,-1,sizeof(tempPos));
	memset(tempValue,-1,sizeof(tempValue));
	int index = 0;
	for (int i = 0; i < 10; i++) 
	{
		CString s_trait = libTrait[i];
		int ch = -1;
		if ((ch = trait.Find(s_trait)) != -1) 
		{
			tempPos[index] = ch;
			tempValue[index] = i;
			index++;
			//ͬ ܳͬ
			while ((ch = trait.Find(s_trait, ch + s_trait.GetLength())) != -1)
			{
				tempPos[index] = ch;
				tempValue[index] = i;
				index++;
			}
		}
	}
	//λý
	for (int i = 0; i < NUMBER_LENGTH; i++) 
	{
		for (int j = i; j < NUMBER_LENGTH; j++) 
		{
			if (tempPos[j] != -1 && tempPos[j] < tempPos[i]) 
			{
				int t = tempPos[i];
				tempPos[i] = tempPos[j];
				tempPos[j] = t;

				t = tempValue[i];
				tempValue[i] = tempValue[j];
				tempValue[j] = t;
			}
		}
	}
	CString all;
	{
		index = 0;
		while(index<NUMBER_LENGTH&&tempValue[index]!=-1)
		{
			CString temp;
			temp.Format("%d",tempValue[index]);
			all += temp;
			index++;
		}
	}
	if(all.GetLength() == 0)
		return -1;
	else
		return atoi(all);//ûֵתΪ0
}

float CGameTool::identFloat(CString trait,CString libTrait[]) 
{
	int tempPos[NUMBER_LENGTH];
	int tempValue[NUMBER_LENGTH];
	memset(tempPos,-1,sizeof(tempPos));
	memset(tempValue,-1,sizeof(tempValue));
	int index = 0;
	for (int i = 0; i < 10; i++) {
		CString s_trait = libTrait[i];
		int ch = -1;
		if ((ch = trait.Find(s_trait)) != -1) 
		{
			tempPos[index] = ch;
			tempValue[index] = i;
			index++;
			//ͬ ܳͬ
			while ((ch = trait.Find(s_trait, ch + s_trait.GetLength())) != -1)
			{
				tempPos[index] = ch;
				tempValue[index] = i;
				index++;
			}
		}
	}
	//λý
	for (int i = 0; i < NUMBER_LENGTH; i++) 
	{
		for (int j = i; j < NUMBER_LENGTH; j++) 
		{
			if (tempPos[j] != -1 && tempPos[j] < tempPos[i]) 
			{
				int t = tempPos[i];
				tempPos[i] = tempPos[j];
				tempPos[j] = t;

				t = tempValue[i];
				tempValue[i] = tempValue[j];
				tempValue[j] = t;
			}
		}
	}
	CString all;
	{
		index = 0;
		while(index<NUMBER_LENGTH&&tempValue[index]!=-1)
		{
			CString temp;
			if(index == 0){
				temp.Format("%d.",tempValue[index]);
			}
			else
			{
				temp.Format("%d",tempValue[index]);
			}
			all += temp;
			index++;
		}
	}
	if(all.GetLength() == 0)
		return -1;
	else
		return (float)atof(all);//ûֵתΪ0
}

//ʶзŵ '/'
void CGameTool::identSign(CString trait,CString libTrait[],int *outArray)
{
	int tempPos[NUMBER_SIGIN_LENGTH];
	int tempValue[NUMBER_SIGIN_LENGTH];
	memset(tempPos,-1,sizeof(tempPos));
	memset(tempValue,-1,sizeof(tempValue));
	int index = 0;
	for (int i = 0; i < 11; i++) 
	{
		CString s_trait = libTrait[i];
		int ch = -1;
		if ((ch = trait.Find(s_trait)) != -1) 
		{
			tempPos[index] = ch;
			tempValue[index] = i;
			index++;
			//ͬ ܳͬ
			while ((ch = trait.Find(s_trait, ch + s_trait.GetLength())) != -1) 
			{
				tempPos[index] = ch;
				tempValue[index] = i;
				index++;
			}
		}
	}
	//λý
	for (int i = 0; i < NUMBER_SIGIN_LENGTH; i++)
	{
		for (int j = i; j < NUMBER_SIGIN_LENGTH; j++) 
		{
			if (tempPos[j] != -1 && tempPos[j] < tempPos[i])
			{
				int t = tempPos[i];
				tempPos[i] = tempPos[j];
				tempPos[j] = t;

				t = tempValue[i];
				tempValue[i] = tempValue[j];
				tempValue[j] = t;
			}
		}
	}
	CString all;
	{
		index = 0;
		while(index<NUMBER_SIGIN_LENGTH&&tempValue[index]!=-1)
		{
			if(tempValue[index] == 10)
			{
				//Ƿ
				all += _T("-");
			}else{
				CString temp;
				temp.Format("%d",tempValue[index]);
				all += temp;
			}
			index++;
		}
	}
	if(all.GetLength() > 0){
		int idex = all.FindOneOf("-");
		outArray[0] = atoi(all.Mid(0,idex));
		outArray[1] = atoi(all.Mid(idex+1));
	}else{
		outArray[0] = -1;
		outArray[1] = -1;
	}
}

// ɨ
CString CGameTool::scanfTraitByColor(int x,int y,int w,int h,int color)
{
	int length = w*h;
	int *data = new int[length];
	memset(data,0,sizeof(int)*length);
	getColors(x,y,w,h,data);
	CString buffer;
	int count = 0;
	for (int i = 0, j = 1; i < length; i++, j++) 
	{
		if (j % h != 0) {
			if (compare(data[i],color)) 
			{
				count++;
			}
		}
		else 
		{
			if (compare(data[i],color))
			{
				count++;
			}
			CString tmp;
			tmp.Format("%d",count);
			buffer += tmp;
			count = 0;
		}
	}
	delete[] data;
	return buffer;
}

// ɨ
CString CGameTool::scanfTrait(int x,int y,int w,int h,int dissolve)
{
	int length = w*h;
	int *data = new int[length];
	memset(data,0,sizeof(int)*length);
	getColors(x,y,w,h,data);
	CString buffer;
	int count = 0;
	for (int i = 0, j = 1; i < length; i++, j++)
	{
		if (j % h != 0) {
			if (colorDissolve(data[i],dissolve))
			{
				count++;
			}
		} 
		else
		{
			if (colorDissolve(data[i],dissolve)) 
			{
				count++;
			}
			CString tmp;
			tmp.Format("%d",count);
			buffer += tmp;
			count = 0;
		}
	}
	delete[] data;
	return buffer;
}

//////////////////////////ɫǷһΧ֮////////////////////////////////////////////////
BOOL CGameTool::colorDissolve(int color,int dissolve )
{
	int red = (color & 0xff0000) >> 16;
	int green = (color & 0x00ff00) >> 8;
	int blue = (color & 0x0000ff);
	if(red+green+blue > dissolve)//ȥɫָɫȷ
		return TRUE;
	return FALSE;
}

/**תMFCʶɫʽ**/
int CGameTool::converColor(int color)
{
	//GetRValue,GetGValue,GetBValue෴
	int rgb[3] = {0};
	int2rgb(color,rgb);
	return rgb2int(rgb[2],rgb[1],rgb[0]);
}

void CGameTool::int2rgb(int color,int *oColor) 
{
	if (oColor != NULL)
	{
		oColor[0] = color >> 16 & 0xff;//red
		oColor[1] = color >> 8 & 0xff;//green
		oColor[2] = color & 0xff;//blue
	}
}

int CGameTool::rgb2int(int r, int g, int b)
{
	int cValue = ((0 & 0xFF) << 24) | ((r & 0xFF) << 16) | ((g & 0xFF) << 8)
		| ((b & 0xFF) << 0);
	return cValue;
}

/////////////ȡµλͼָλ/////////////
COLORREF CGameTool::getColor(int x,int y)
{
	updatePixel();//ȡ
	return getCurColor(x,y);
}

/////////////ȡǰָλ/////////////
COLORREF CGameTool::getCurColor(int x,int y)
{
	COLORREF color = 0;
	if (x>=0&&y>=0&&x<pix_width&&y<pix_height)
	{
		///////////////////////cppɫʽλû///////////////////////
		BYTE r = pix_data[x * nbyte + y * bmWidthBytes + 2];
		BYTE g = pix_data[x * nbyte + y * bmWidthBytes + 1];
		BYTE b = pix_data[x * nbyte + y * bmWidthBytes];
		color = rgb2int(r,g,b);//ɫΪPHOTOSHOPɫ
	}
	return color;
}

/////////////ȡµλͼָλ/////////////
void CGameTool::getColors(int x,int y,int w,int h,int *colors)
{
	updatePixel();//ȡ
	return getCurColors(x,y,w,h,colors);
}

/////////////ȡǰָλ/////////////
void CGameTool::getCurColors(int x,int y,int w,int h,int *colors)
{
	COLORREF color = 0;
	int index = 0;
	int width = x+w;//СͼƬĿ
	int height = y+h;//СͼƬĸ߶
	if (x<0||y<0||x>=pix_width||y>=pix_height
		||width>=pix_width||height>=pix_height)
	{
		println("ɨСԽ");
		return;
	}
	for (int i = x;i < width;++i)
	{
		for (int j = y;j < height;++j)
		{
			///////////////////////cppɫʽλû///////////////////////
			BYTE r = pix_data[i * nbyte + j * bmWidthBytes + 2];
			BYTE g = pix_data[i * nbyte + j * bmWidthBytes + 1];
			BYTE b = pix_data[i * nbyte + j * bmWidthBytes];
			colors[index++] = rgb2int(r,g,b);//ɫΪPHOTOSHOPɫ
		}
	}
}

///////////////////////cppɫʽ///////////////////////
COLORREF CGameTool::getPixel(int x,int y)
{
	return ::GetPixel(this->hDc,x,y);
}

CPoint CGameTool::findPointFromColor(int x,int y,int w,int h,int color)
{
	CPoint cp(-1,-1);
	updatePixel();//ȡ
	int pt = 0;
	int width = x+w;//СͼƬĿ
	int height = y+h;//СͼƬĸ߶
	if (x<0||y<0||x>=pix_width||y>=pix_height
		||width>=pix_width||height>=pix_height)
	{
		println("ɨСԽ");
		return cp;
	}
	int rgb[3] = {0};
	int2rgb(color,rgb);
	for (int i = x;i < width;++i)
	{
		for (int j = y;j < height;++j)
		{
			///////////////////////cppɫʽλû///////////////////////
			BYTE r = pix_data[i * nbyte + j * bmWidthBytes + 2];
			BYTE g = pix_data[i * nbyte + j * bmWidthBytes + 1];
			BYTE b = pix_data[i * nbyte + j * bmWidthBytes];
			if(rgb[0]==r&&rgb[1]==g&&rgb[2]==b)
			{
				cp.x = i;
				cp.y = j;
			}
		}
	}
	return cp;
}

//COLORΪɫֵ  ɫ
int CGameTool::findNumberWidthColor(int x,int y,int w,int h,int color)
{
	updatePixel();//ȡ
	int pt = 0;
	int width = x+w;//СͼƬĿ
	int height = y+h;//СͼƬĸ߶
	if (x<0||y<0||x>=pix_width||y>=pix_height
		||width>=pix_width||height>=pix_height)
	{
		println("ɨСԽ");
		return -1;
	}
	int rgb[3] = {0};
	int2rgb(color,rgb);
	for (int i = x;i < width;++i)
	{
		for (int j = y;j < height;++j)
		{
			///////////////////////cppɫʽλû///////////////////////
			BYTE r = pix_data[i * nbyte + j * bmWidthBytes + 2];
			BYTE g = pix_data[i * nbyte + j * bmWidthBytes + 1];
			BYTE b = pix_data[i * nbyte + j * bmWidthBytes];
			if(rgb[0]==r&&rgb[1]==g&&rgb[2]==b)
				pt++;
		}
	}
	return pt;
}

void CGameTool::tokenize(CString text,CString split,CArray<CString> *list)
{
	CString partStr;
	int position = 0;
	do 
	{
		partStr = text.Tokenize(split,position);
		if (partStr != "")
		{
			list->Add(partStr);
		}
	} while (!partStr.IsEmpty());
}

//ͬĲ
CString CGameTool::getSubString(CString str1, CString str2) 
{
	CString targetString;
	// ȡн϶̵ַ(չЧ)
	CString shorter = str1.GetLength() > str2.GetLength() ? str2 : str1;
	CString longer = str1.GetLength() > str2.GetLength() ? str1 : str2;

	// ڽ϶̵ַгȡ䡮гȡӴ˳ɳ
	for (int subLength = shorter.GetLength(); subLength > 0; subLength--)
	{
		// ӴʼǱ 0 ʼƣֱӴβĸβ-غΪֹ
		for (int i = 0; i + subLength <= shorter.GetLength(); i++) 
		{
			CString subString = shorter.Mid(i, i + subLength); // ȡӴ
			if (longer.Find(subString) >= 0) 
			{ // ע =
				targetString = subString;
				return targetString;
			}
		}
	}
	return "0";
}
BOOL CGameTool::doCheck(int eventArray[])
{
	return doCheck(eventArray,1);
}

/***꣬***/
BOOL CGameTool::doCheck(int eventArray[],int sleepTime)
{
	if(!isWorking())//ֹͣһ
		return FALSE;
	sleep(sleepTime);
	//////eventArray left,top,right,bottom,color
	int x = eventArray[0];
	int y = eventArray[1];
	int w = eventArray[2];
	int h = eventArray[3];
	int color = eventArray[4];
	int eventColors = findNumberWidthColor(x,y,w,h,color);
	if(eventColors>=1)
		return TRUE;
	return FALSE;
}

BOOL CGameTool::compare(COLORREF src,COLORREF dst)
{
	int red = (src & 0xff0000) >> 16;
	int green = (src & 0x00ff00) >> 8;
	int blue = (src & 0x0000ff);

	int r = (dst & 0xff0000) >> 16;
	int g = (dst & 0x00ff00) >> 8;
	int b = (dst & 0x0000ff);

	//println("[%d,%d,%d]-[%d,%d,%d]",red,green,blue,r,g,b);

	if(red==r&&green==g&&blue==b)
		return TRUE;
	else
		return FALSE;
}

int CGameTool::sort(int data[],int length)
{
	for (int i=0;i<length;i++)
	{
		for (int j=i;j<length;j++)
		{
			if (data[j] > data[i]) {
				int t = data[i];
				data[i] = data[j];
				data[j] = t;
			}
		}
	}
	return data[0];
}

void CGameTool::sendMouseClick(long x,long y)
{
	if (isWorking())
	{
		LPARAM lParam = MAKELONG(x, y);
		::SendMessage(this->gameHwnd, WM_MOUSEMOVE, NULL, lParam);
		::SendMessage(this->gameHwnd, WM_LBUTTONDOWN, NULL, lParam);
		::SendMessage(this->gameHwnd, WM_LBUTTONUP, NULL, lParam);
	}
}

void CGameTool::sendMouseClick_Random(long x,long y)
{
	if (isWorking())
	{
		int rx = abs((rand()%5));
		int ry = abs((rand()%5));
		//һֵֹϷ¼ÿελһ
		LPARAM lParam = MAKELONG(x + rx, y + ry);
		::SendMessage(this->gameHwnd, WM_MOUSEMOVE, NULL, lParam);
		::SendMessage(this->gameHwnd, WM_LBUTTONDOWN, NULL, lParam);
		::SendMessage(this->gameHwnd, WM_LBUTTONUP, NULL, lParam);
	}
}

BOOL CGameTool::waitForLoad(int colorArray[])
{
	for (int i=0;isWorking()&&i<SCANF_TIME_OUT;i++)
	{
		if (doCheck(colorArray))
		{
			return TRUE;
		} 
		else
		{
			sleep(1000);
		}
	}
	return FALSE;
}

void CGameTool::copyToClip(CString text)
{
	if(OpenClipboard(NULL))
	{
		EmptyClipboard();
		HANDLE hClip; 
		TCHAR *pBuf; 
		SIZE_T st = (text.GetLength()+1)*2;
		hClip = GlobalAlloc(GMEM_MOVEABLE, st);
		if (hClip)
		{
			pBuf = (TCHAR*)GlobalLock(hClip); 
			memcpy(pBuf,text,st);
			GlobalUnlock(hClip); 
			SetClipboardData(CF_TEXT,hClip); 
			GlobalFree(hClip);
		} 
		else
		{
			AfxMessageBox("ڴʧ");
		}
	}
	CloseClipboard();
}

void CGameTool::checkScreenBits()
{
	HDC screenDC;
	int colorBits,xRes,yRes;
	screenDC = CreateDC(_T("DISPLAY"),NULL,NULL,NULL);
	/* 豸 */
	colorBits = GetDeviceCaps(screenDC,BITSPIXEL);
	if (colorBits != 32)
	{
		println("ȷʾɫǷΪ32ɫ");
	}
	xRes = GetDeviceCaps(screenDC,HORZRES);
	yRes = GetDeviceCaps(screenDC,VERTRES);
	/*  */
	DeleteDC(screenDC);
}

void CGameTool::println(LPCTSTR strFormat,...)
{
	va_list valist;
	va_start(valist, strFormat);
	CString text;
	text.FormatV(strFormat, valist);
	AfxMessageBox(text);
	va_end(valist);
}


int CGameTool::hexToDem(CString str)
{
	int dem=0;
	for(int i=0;i<str.GetLength();i++)
	{
		dem=dem*16;
		if((str[i]<='9')&&(str[i]>='0'))        //0~9ַ֮
			dem+=str[i]-'0';
		else if((str[i]<='F')&&(str[i]>='A'))   //A~Fַ֮
			dem+=str[i]-'A'+10;
		else if((str[i]<='f')&&(str[i]>='a'))   //a~fַ֮
			dem+=str[i]-'a'+10;
		else
			return -1;                          //ʱ-1
	}
	return dem;     
}

int CGameTool::getBeginFirstPosition(CString str)
{
	for(int i=0;i<str.GetLength();i++){
		if(str.GetAt(i)!='0')
			return i;
	}
	return -1;
}

int CGameTool::getEndLastPosition(CString str)
{
	for(int i=str.GetLength()-1;i>=0;i--){
		if(str.GetAt(i)!='0')
			return i;
	}
	return -1;
}

////ȥβ0
CString CGameTool::processString(CString text)
{
	int beginIndex = getBeginFirstPosition(text);
	int endIndex = getEndLastPosition(text);
	////////////////һcount,Ҫȥǰ濪ʼλü1
	CString resultStr = text.Mid(beginIndex,endIndex-beginIndex+1);
	return resultStr;
}